from db2_imports.models import QueryConfig

queries = [
    QueryConfig(
        name="mon_get_database",
        query="""
        WITH MON_DATABASE
             AS (SELECT *
                 FROM   Table(MON_GET_DATABASE({member_scope}))),
             MON_LOG
             AS (SELECT *
                 FROM   Table(MON_GET_TRANSACTION_LOG({member_scope})))
        SELECT *
        FROM   MON_DATABASE
               INNER JOIN MON_LOG
                       ON MON_LOG.MEMBER = MON_DATABASE.MEMBER
        """,
        will_run_now=True,
        dimension_columns=["member"],
        value_columns=[],
    ),
    QueryConfig(
        name="last_backup",
        query="""
        SELECT TO_CHAR(LAST_BACKUP,'YYYY-MM-DD-HH24:MI:SS') AS LAST_BACKUP, MEMBER
            FROM TABLE(MON_GET_DATABASE({member_scope}))
        """,
        will_run_now=True,
        dimension_columns=["member"],
        value_columns=[],
    ),
    QueryConfig(
        name="mon_transaction_log_utilization",
        query="SELECT MEMBER, TOTAL_LOG_USED_KB, TOTAL_LOG_AVAILABLE_KB FROM SYSIBMADM.MON_TRANSACTION_LOG_UTILIZATION",
        will_run_now=True,
        dimension_columns=["member"],
        value_columns=[],
    ),
    QueryConfig(
        name="mon_get_tablespace",
        query="""SELECT MEMBER, TBSP_NAME, TBSP_TOTAL_PAGES, TBSP_USED_PAGES 
        FROM TABLE(MON_GET_TABLESPACE(NULL, {member_scope})) 
        ORDER BY TBSP_USED_PAGES DESC 
        LIMIT 1000""",
        will_run_now=True,
        dimension_columns=["member", "tbsp_name"],
        value_columns=[],
    ),
]
